#version 130
precision mediump float;

uniform sampler2D ctexture;
uniform vec4 frag_color;

// fragment-shader input variables
in vec2 fragTexCoord;

// fragment-shader output variable (-> stored in the frame-buffer, i.e. "the pixel you see")
out vec4 fragColor;

void main()
{
    vec4 texel = texture(ctexture, fragTexCoord);
    
    if(texel.w < 0.01){
		discard;
    }
    
    if(frag_color.w == 0.0f){
		fragColor = texel;
    }else{
		fragColor = texel * frag_color;
    }
}
